"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConfiguration = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const uuid_1 = require("uuid");
const configuration_1 = __importDefault(require("../configuration"));
const utils_1 = require("../utils");
async function createConfiguration() {
    try {
        if (await (0, utils_1.fileExists)(configuration_1.default.configFilePath)) {
            return;
        }
        await fs_1.default.promises.mkdir(path_1.default.join(configuration_1.default.homePath, ".spheron"), {
            recursive: true,
            mode: 0o777,
        });
        await fs_1.default.promises.chmod(path_1.default.join(configuration_1.default.homePath, ".spheron"), 0o777);
        const id = (0, uuid_1.v4)();
        await (0, utils_1.writeToJsonFile)("id", id, configuration_1.default.configFilePath);
        await fs_1.default.promises.chmod(configuration_1.default.configFilePath, 0o777);
        await (0, utils_1.writeToJsonFile)("projects", [], configuration_1.default.projectTrackingFilePath);
        await fs_1.default.promises.chmod(configuration_1.default.projectTrackingFilePath, 0o777);
    }
    catch (error) {
        console.log(`✖️  Error: ${error.message}`);
    }
}
exports.createConfiguration = createConfiguration;
