"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ora_1 = __importDefault(require("ora"));
const chalk = require("chalk");
function wait(opts, delay = 300) {
    let text = opts.text;
    let spinner = null;
    if (typeof text !== "string") {
        throw new Error(`"text" is required for Ora spinner`);
    }
    const timeout = setTimeout(async () => {
        spinner = (0, ora_1.default)(opts);
        spinner.text = chalk.gray(text);
        spinner.color = "gray";
        spinner.start();
    }, delay);
    const stop = async () => {
        clearTimeout(timeout);
        if (spinner) {
            spinner.stop();
            spinner = null;
        }
    };
    stop.text = text;
    Object.defineProperty(stop, "text", {
        get() {
            return text;
        },
        set(v) {
            text = v;
            if (spinner) {
                spinner.text = v;
            }
        },
    });
    return stop;
}
exports.default = wait;
